%================================================================
% LaTeX file with preferred layout for H1 paper drafts
% use: dvips -D600 file-name
%================================================================
\documentclass[12pt]{article}
\usepackage{amsmath}
%\usepackage{color}
\usepackage{fancybox,amssymb}

\include{def-jhep-journals}

% create new 'if' command: ifpdf
\newif\ifpdf
 \ifx\pdfoutput\undefined
 \pdffalse                 % we are not running PDFLaTeX
\else
 \pdfoutput=1              % we are running PDFLaTeX
 \pdftrue
\fi


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\ifpdf  % PDFLatex
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  include packages necessary for
%  pdflatex ONLY
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \pdfadjustspacing=1 %get the same spacing as in Latex
 \pdfcompresslevel=0
 \usepackage{url,xspace,boxedminipage}
 \usepackage{graphicx,thumbpdf}
 %\definecolor{rltred}{rgb}{0.75,0,0}
 %\definecolor{rltgreen}{rgb}{0,0.5,0}
 %\definecolor{rltblue}{rgb}{0,0,0.75}

 \usepackage[pdftex, %colorlinks,                          
  ,bookmarks                                             
  ,bookmarksnumbered
  ,hyperindex
%  ,urlcolor=rltblue%
%  ,filecolor=rltgreen %rltgreen%
%  ,linkcolor=rltgreen %rltred
  ,pdftitle={Physics eXtension Library (PXL)}%
  ,pdfsubject={PXL}%
  ,pdfkeywords={PXL, C++}%
  ,pdfauthor={Martin Erdmann<erdmann@cern.ch>}%
  ,pdfpagemode={UseOutlines}%
  ,pdfstartview={Fit}%
  ]{hyperref}
 \pdfimageresolution=300                                
 \DeclareGraphicsExtensions{.pdf,.jpg,.jpeg}  % Grafik-Endungen

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\else  % Latex
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%  include packages necessary for
%  latex ONLY (PS output file)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \usepackage{graphicx}                        
   \DeclareGraphicsExtensions{.eps,.ps,.eps.gz,.ps.gz} % Grafik-Endungen
  
  \newcommand{\href}[2]{#2} % neccessary to suppress urls in the PS output file
  \usepackage[dvips,pagebackref]{hyperref} % always use hyperref at last
                                           % needed to get Pagebackref's in the
                                           % Bibliography       
\fi

%\definecolor{myorange}{rgb}{0.8,0.2,0.0}
%\def\red{\color{myorange}}
%\def\blue{\color{blue}}
%\def\orange{\color{myorange}}

\DeclareGraphicsRule{*}{mps}{*}{}
\graphicspath{./}


\renewcommand{\topfraction}{1.0}
\renewcommand{\bottomfraction}{1.0}
\renewcommand{\textfraction}{0.0}

\newcommand{\bredb}[1]{{\bf\red #1 }} %makes text in \bf\red
\newcommand{\bblueb}[1]{{\bf\blue #1 }} %makes text in \bf\blue
\newcommand{\blfi}[1]{{\blue #1}} % writes #1 in

\newlength{\dinwidth}
\newlength{\dinmargin}
\setlength{\dinwidth}{21.0cm}
\textheight23.5cm \textwidth17.0cm
\setlength{\dinmargin}{\dinwidth}
\setlength{\unitlength}{1mm}
\addtolength{\dinmargin}{-\textwidth}
\setlength{\dinmargin}{0.5\dinmargin}
\oddsidemargin -1.0in
\addtolength{\oddsidemargin}{\dinmargin}
\setlength{\evensidemargin}{\oddsidemargin}
\setlength{\marginparwidth}{0.9\dinmargin}
\marginparsep 8pt \marginparpush 5pt
\topmargin -42pt
\headheight 12pt
\headsep 30pt \footskip 24pt
\parskip 3mm plus 2mm minus 2mm


%===============================title page=============================
\begin{document}

\pagestyle{empty}

\include{kerneltitlepage}
\include{license}

\newpage
\tableofcontents


\newpage
\pagestyle{plain}
\setcounter{page}{3}

\section{\large Overview}
\label{sec_intro}
\noindent
%
The Physics eXtension Library (PXL) is a class collection for the
advanced level analysis in a high energy physics experiment \cite{pxl-web,auto}.  
PXL classes are based on the ANSI C++ language standard together with the
Standard Template Library (STL). The user command syntax of PXL is
designed to support experienced users as well as newcomers in developing
their own analysis, reaching from simple selection algorithms to most
complex multi-process analyses with solving the reconstruction of
ambiguous decay trees from the final state objects measured in a detector.\\
\\
During the analysis of a high energy physics data event, PXL
enables storing all event information in PXL objects (\emph{pxl::Object}) such
as particles, vertices or collisions. 
Each of these objects allows storing all information users need 
to keep for their analysis. 
In addition, the library allows users to inherit features from PXL classes
into user-owned classes in order to maintain structures of their analysis-specific event information. 
Between all objects, PXL objects or user defined objects, 
relations can be established, for example to build particle decay trees.\\
\\
As described so far, PXL objects contain single aspects of an individual
event. In order to maintain information about a whole process, PXL
provides the building block EventView (\emph{pxl::EventView}). 
The latter is a generalized object container where, in addition to the aforementioned 
physics objects, also user information can be stored.\\
\\
Beyond providing the relation management for building up the decay
trees, PXL enables efficient duplication of already filled event 
containers with all particles, relations, and user information.\\ 
\\
\begin{figure}[h]
\begin{center}
\setlength{\unitlength}{1cm}
\begin{picture}(11.5,7.5)
{\includegraphics[width=11.5cm]{plots/intro_plot}}
\end{picture}
\caption{Physics event which contain two event views: generated and reconstructed,
particles (solid lines) and vertices (red points).}
\label{fig_intro}
\end{center}
\end{figure}\\
\\
This allows users, e.g., to comfortably build all ambiguous reconstruction 
versions in the reconstruction procedure of a decay tree from final state 
particles. In order to keep CPU and memory consumption small, PXL here employs 
a copy-on-write mechanism (COW).\\
\\
The largest buiding block PXL provides is the class Event (\emph{pxl::Event})
which enables holding all possible EventViews the user wishes to keep for a high
energy collision event.\\
\\
The PXL package can be used as a standalone package, or alternatively within
the software framework of a specific high energy physics experiment. 
Access to and installation of the package is straightforward, either via a tar-file, or an SVN server, or the bundled files PXL.cc and PXL.hh. 
PXL can be installed on any PC platform. 
%PXL provides methods for storing and 
%retrieving objects of the user physics analysis.


\section{Concept and Structure of PXL}
\label{sec_concept}

PXL provides a flexible relation management 
for reconstructing decay trees in High Energy Physics (HEP) processes.
For this task relations can be set between decay chain objects, i.e. 
mother and daughter particles, vertices and collisions. 
The main component of the high energy physics analysis is a physics 
event which is contained in the class \emph{pxl::Event}.
All objects, such as particles or vertices which belong to one physics 
event, can be collected in all possible \emph{pxl::EventView}s of a 
given \emph{pxl::Event}. More specific information about the
objects such as b-tags, jet cone sizes, or energy corrections can also be 
stored with the objects by means of the so-called user records 
(\emph{pxl::UserRecord}). 

\subsection{Particle, Vertex, Collision: Physics Objects}
The physics reconstruction process requires records of primary 
interaction vertices as well as particle parameters. Frequently, users
take advantage of experiment-specific classes, or they implement 
their own C++ classes in order to maintain this 
information. By using PXL, in addition, they can profit from the PXL 
relation menagement. Before this possibility is described, the usage of PXL 
is explained with the objects offered within PXL.
%
\begin{itemize}
\item \emph{pxl::Particle}~ represents particles or other reconstructed objects
	(muons, electrons, jets etc.). This class offers a
	four-vector, charge, particle-id, and user records. 
\item \emph{pxl::Vertex}~ represents the spatial point of a decay in the given 
	reaction. This class has a three-vector and user records.
\item \emph{pxl::Collision}~ allows the separation of the collisions in 
	multicollision events using a relation management strategy. Similar
	to particle and vertex, this class also contains user records.
\end{itemize}
%-
All these objects inherit from the more general \emph{pxl::Object}
class (see Fig.\,\ref{fig_phys_obj}).. 
%
\begin{figure}[t]
\begin{center}
\setlength{\unitlength}{1cm}
\begin{picture}(14.0,7.0)
{\includegraphics[width=15cm]{plots/fig_basic_object}}
\end{picture}
\caption{Inheritance diagram for \emph{pxl::Object}.}
\label{fig_phys_obj}
\end{center}
\end{figure}
%
In this way, they can establish necessary relations and also can be stored in
object containers such as \emph{pxl::EventView} and can be written to a file. 
There is a number of 
methods available for all basic physics objects. One example is the method
to look at the contents stored in the object \emph{print()}. 
For example, to assign a corresponding name to the particular object or to 
get information about an object name, one can use the \emph{setName()} 
and \emph{getName()} methods: \\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void pxl::BasicObject::print()}\\
\emph{void pxl::BasicObject::setName(std::string)}\\
\emph{std::string pxl::BasicObject::getName()}
\vspace{0.2cm}
\end{minipage}}\\
\\
%-
In the program code these methods can be used as follows:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{pxl::Particle* t = new pxl::Particle();}\\
\texttt{t->setName("top");}\\
\texttt{std::string tName = t->getName();}\\
\texttt{std::cout << "particle name" << tName << std::endl;}\\
\texttt{t->print();}\\
\texttt{delete t;}
\vspace{0.2cm}
\end{minipage}}

\subsection{User Records}
\label{sebsec_urec}
The user can store additional information, e.g. about the generator events 
or reconstruction algorithm in PXL objects, by means of user records. 
This additional data can be stored in standard double, integer, pointer,
string and other ("variant") basic data types.
The \emph{pxl::UserRecord} class
provides methods for quick access to individual user record entries and can
assemble information complementary to data members in the form of string-variant 
pairs. 
There are several template methods available for the class \emph{pxl::UserRecord}. 
To insert (or replace) the user record identified by \emph{key}, one can use
the \emph{set()} template method.\\
\\
There is also a set of methods developed in order to operate with 
user records of the objects:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void pxl::Object::setUserRecord$\langle$datatype$\rangle$(const std::string} \&\emph{key, const datatype} \&\emph{item)}\\
\emph{void pxl::Object::removeUserRecord(const std::string} \&\emph{key)}  
\vspace{0.2cm}
\end{minipage}}\\
\\
The \emph{setUserRecord()} template method sets the user record entry 
identified by \emph{key} to \emph{item}, and \emph{removeUserRecord()} 
removes the user record entry identified by \emph{key}. 
In order to find a user record, the two options of \emph{findUserRecord()} can be used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{datatype pxl::BasicObject::findUserRecord$\langle$datatype$\rangle$} \\
\,\,\,\, \emph{(const std::string} \&\emph{key, const datatype} \&\emph{defaultitem)}\\  
\emph{datatype pxl::BasicObject::findUserRecord(const std::string}\&\emph{key)}  
\vspace{0.2cm}
\end{minipage}}\\
\\
In the first case the method searches the user record entry identified by 
\emph{key} and returns \emph{defaultitem} in case \emph{key} is not found. 
Using the second option, the method also searches the user record entry 
identified by \emph{key}, however in this case an exception is thrown 
if \emph{key} is not found.\\ 
\\
Let us consider an example of a muon produced in top quark decay 
(see Figure\,\ref{fig_s-chan}) where we want to define an isolation criterion, 
keep it in a user record, find the user record and delete this user record 
afterwards: \\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{pxl::Particle* mu = new pxl::Particle();}\\
\texttt{mu->setName("muon");}\\ 
\texttt{mu->setUserRecord<double>("Isolation",2.5);}\\ 
\texttt{double mu\_iso = mu->findUserRecord<double>("Isolation");}\\ 
\texttt{std::cout << "Isolation parameter:" << mu\_iso << std::endl;}\\
\texttt{mu->removeUserRecord("Isolation");}\\
\texttt{delete mu;}
\vspace{0.2cm}
\end{minipage}}\\
\\
In order to assure the existence of the user record the \emph{check()} method 
template can be used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{bool pxl::UserRecord::check(const std::string} \&\emph{key) const}\\
\emph{bool pxl::UserRecord::check$\langle$datatype$\rangle$(const std::string} \&\emph{key datatype} \&\emph{item) const}
\vspace{0.2cm} 
\end{minipage}}\\
\\
Both versions of this method return \emph{true} if a user record entry 
identified by \emph{key} is present. In addition, in the second version its value (if present) is put into the argument 
(\emph{item}).


%-
\subsection{Relation Management}
PXL allows to set relations between objects of various classes. An example
is the relation between a mother and a daughter particle in a particle
decay tree. 
To keep the integrity of the decay tree, the class \emph{pxl::Relative} 
allows to establish relations only to objects contained in the same object 
owner (object container), and each object can only have one owner.
Relations between a mother particle and its decay product(s) 
(daughter-particles) are established by:\\ 
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void linkDaughter (pxl::Relative *target)}\\
\emph{void linkMother (pxl::Relative *target)}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
%
\begin{figure}[t]
\begin{center}
\setlength{\unitlength}{1cm}
\begin{picture}(6.0,3.5)
{\includegraphics[width=7cm]{plots/feynman_t_ljetsqq_bold}}
\end{picture}
\caption{ Single top quark decay Feynman diagram.}
\label{fig_s-chan}
\end{center}
\end{figure}
%
The relation between these objects can be removed using the following 
functions:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void unlinkMother (pxl::Relative *target)}\\
\emph{void unlinkDaughter (pxl::Relative *target)}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
%
Let us consider the following example, a decay of a single top quark as 
illustrated in Figure \ref{fig_s-chan}. The top quark decays into two 
particles, a $W^{+}$-boson and a $b$-quark. In this case the $W^{+}$ and the 
$b$ correspond to the daughter particles of the 
decay and the top quark is the mother particle. Here we set mother-daughter 
relations between these particles:\\ 
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// here we establish our particles:}\\
\texttt{pxl::Particle* t = new pxl::Particle();}\\
\texttt{pxl::Particle* W = new pxl::Particle();}\\
\texttt{pxl::Particle* b = new pxl::Particle();}\\
\texttt{pxl::Particle* nu = new pxl::Particle();}\\
\\
\texttt{// link two daughters two one mother:}\\
\texttt{W->linkMother(t);}\\
\texttt{b->linkMother(t);}\\
\texttt{// or t->linkDaughter(W); t->linkDaughter(b); to attain the same result}\\
\\
\texttt{// create relations beyond the mother-daughter relations in the decay}\\
\texttt{// cascade:}\\%%does this make sense? I think this is rather misleading since there should be mother-daughter-relations according to the Feynman diagram (-Jan-).
\texttt{nu->linkFlat(t);}\\
\texttt{nu->linkFlat(b);}\\
\\
\texttt{// delete all created particles:}\\
\texttt{delete t;}\\
\texttt{delete W;}\\
\texttt{delete b;}\\
\texttt{delete nu;}
\vspace{0.2cm}
\end{minipage}}\\
\\
The same structure can be created with PXL for the $W^{+}$ decaying into 
a lepton-neutrino or $q\bar{q}$ pair. In addition, also flat relations can be established between two objects contained in the same object owner.
\\
% To keep the integrity of the decay tree, the class \emph{pxl::Relative} 
% allows to establish mother-daughter relations or \emph{flat relations} 
% between any objects contained in the same object owner (object container).\\
\\
As an alternative, general relations are also possible between arbitrary
objects using the PXL \emph{soft relations} concept. One can establish
soft relations using the following function:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void linkSoft (pxl::Relative *target)}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
as well as check the existance of the relation using method
templates such as \emph{has()} or \emph{hasType()}. Related objects can be accessed via the methods \emph{int pxl::SoftRelations::getSoftRelatives(..)} and \emph{pxl::Relative* pxl::SoftRelations::getFirst(..)}.
Here is an example how soft relations can be established and checked:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// our objects for reconstructed (1) and generated (2) event views:}\\
\texttt{pxl::EventView* generatorView = new pxl::EventView();}\\
\texttt{pxl::EventView* recoView = new pxl::EventView();}\\
\texttt{pxl::Particle* p1 = generatorView->create<pxl::Particle>();}\\
\texttt{pxl::Particle* p2 = recoView->create<pxl::Particle>();}\\
\texttt{pxl::Vertex* v1 = recoView->create<pxl::Vertex>(pxl::Vertex();}\\
\texttt{pxl::Collision* c1 = generatorView->create<pxl::Collision>(;}\\
\\
\texttt{// link a particle p1 to several other objects:}\\
\texttt{p1->linkSoft(p2, "gen-reco");}\\
\texttt{p1->linkSoft(v1, "particle-vertex");}\\
\texttt{p1->linkSoft(c1, "particle-collision");}\\
\\
\texttt{// check if soft relations exist:}\\
\texttt{if (p1->getSoftRelations().has(p2))}\\
\texttt{std::cout << "Soft relation to p2 exists." << std::endl;}\\
\texttt{if (p1->getSoftRelations().hasType("particle-collision"))}\\
\texttt{std::cout << "Soft relation named 'particle-collision' exists." << std::endl;}\\
\texttt{pxl::Particle* (p1->getSoftRelations().getFirst(recoView, "particle-collision"))}\\
\texttt{std::cout << "Soft relation named 'particle-collision' exists." << std::endl;}\\
\\
\texttt{// delete all created objects:}\\
\texttt{delete generatorView;}\\
\texttt{delete recoView;}
\vspace{0.2cm}
\end{minipage}}\\


\subsection{Event, Event View: Object Owner}

The complete information of one multi-collision event with decay trees, 
spatial vertex information, four-momenta as well as additional 
event-related reconstruction data contained in the user records is 
stored in an object container, \emph{pxl::Event}, which can hold
several sub-containers \emph{pxl::EventView} (e.g. for generated and 
reconstructed event hypotheses).
Physics objects (i.e. instances of the classes \emph{pxl::Particle}, 
\emph{pxl::Vertex} or \emph{pxl::Collision}) as well as other arbitrary 
\emph{pxl::Relative} derivatives can be aggregated and managed 
within the object container(s). The name \emph{Event} is pretty 
straightforward. The name \emph{EventView} arises from the fact 
that it is intended to represent a distinct view of an event (e.g. 
connecting particles to a decay tree according to one out of a number 
of hypotheses, applying different jet energy corrections, etc.). 
To facilitate the development of numerous parallel or subsequent event 
views, as needed for hypothesis evolution, for instance, this class features 
a copy constructor which provides a deep copy of the object container with 
all data members, physics objects, and their (redirected) relations. 
The efficient handling of data results in low CPU and memory overhead. 
This way, PXL provides a flexible generalized event container with 
comfortable high-performance duplication functionality, meeting the needs 
of HEP analyses in channels with ambiguous event topologies.

\subsubsection*{Object Owner}
General objects in PXL (\emph{pxl::Relative} derivatives), such as 
\emph{pxl::EventView}, \emph{pxl::Particle} or \emph{pxl::Vertex}, 
can be contained and managed in so-called 'object 
owners' \emph{pxl::ObjectOwner}. In our case, ``managed" means that if 
an object is added to an object owner, it is automatically deleted once the
object owner is deleted.
A typical example for a class which has (contains) an object owner and, hence 
behaves like one is 
\emph{pxl::EventView}, which we will consider further. 
All objects inside these containers belong to the owner and can be 
operated through it. 
Here we describe several template methods available for the
\emph{pxl::ObjectOwner} class which can be accessed from \emph{pxl::EventView} or \emph{pxl::Event} via the \emph{getObjectOwner()} method.
For example, using the \emph{create()} template method, one 
can create derivatives of the \emph{pxl::Relative} within the object owner:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{objecttype* pxl::ObjectOwner::create$\langle$objecttype$\rangle$()} \\
\emph{objecttype* pxl::ObjectOwner::create$\langle$objecttype$\rangle$(const objecttype* original)} \\
\emph{objecttype* pxl::ObjectOwner::create$\langle$objecttype, ctrtype$\rangle$(const ctrtype} \& \emph{original)}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
%-
In the first case the method template creates a new instance of \emph{objecttype}
which must be a class inheriting from \emph{pxl::Relative}. 
Using the argument \emph{original} (second and third options), the template method creates 
a copy of \emph{original} (by invoking the overloaded constructor \emph{ctrtype} in the third case).
In all cases, an \emph{objecttype} must be a class inheriting 
from \emph{pxl::Relative} and the newly created instance is owned and will be 
deleted by the object owner.\\
\\
With the template methods \emph{set()} and \emph{remove()} one can manually 
insert objects (\emph{item}) in the container of this object owner and 
delete \emph{item} from the container:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{pxl::ObjectOwner::set(pxl::Relative* item)} \\
\emph{pxl::ObjectOwner::remove(pxl::Relative* item)}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
A simple test for the object ownership can be performed 
using the \emph{has()} template method: \\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void pxl::ObjectOwner::has(const pxl::Relative* item)}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
This method returns true, if \emph{item} is owned by this object owner.
If the user wants to clear the object owner and delete all owned 
objects, the \emph{clearContainer()} method can be used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{void pxl::ObjectOwner::clearContainer()}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
%-
Along with  methods which allow to add and remove objects
from the container, the object owner also provides additional 
functionalities in order to operate with contained events. For example, the
method \emph{findCopyOf()} searches the copy history to locate the copy of 
an original \emph{Relative} and returns a dynamically casted C++ pointer 
of type \emph{objecttype*} to the corresponding copy. 
In case no copy can be traced, or can not be casted a null pointer is
returned:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{objecttype* pxl::ObjectOwner::findCopyOf$\langle$objecttype$\rangle$(const pxl::Relative* original) const}\\
\emph{const pxl::CopyHistory}\& \emph{pxl::ObjectOwner::getCopyHistory() const }\\
\emph{const pxl::ObjectOwner::clearCopyHistory()}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
The \emph{getCopyHistory()} method provides direct access to the complete 
copy history (created by the copy constructor) and using  
\emph{clearCopyHistory()} this copy can be cleared.\\
\\
Another useful tool for direct object access are the index-ids or object-ids: 
\emph{index} allows to map every single objects onto a unique string identifier. 
To assign an object asertain index, the \emph{setIndex()} method is used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\begin{tabular}{l l l l}
\emph{bool pxl::ObjectOwner::setIndex(} & \emph{const std::string} \emph{idx},& & \\
		& \emph{pxl::ObjectBase* obj}, & &\\ 
		& \emph{bool overwrite = false)} & & 
\end{tabular}
\vspace{0.2cm} 
\end{minipage}}\\
\\
It registers the object \emph{obj} with the index-id \emph{idx} in the index 
and returns true in case of success. In case the index string is already 
present, false is returned by default.
A flag can be set which allows overwriting. Please notice here that \emph{obj} 
must be owned by this object owner and \emph{idx} must not be a zero length string.\\ 
\\
To find a requested object in the container the template method \emph{findObject()} method can be 
used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{objecttype* pxl::ObjectOwner::findObject$\langle$objecttype$\rangle$(const std::string} \& \emph{idx) const}
\vspace{0.2cm}
\end{minipage}}\\
\\
This method searches the index for the index-id \emph{idx} and returns a 
dynamically casted C++ pointer of type \emph{objecttype*} to the corresponding 
object. In case \emph{idx} is not found or cannot be casted a null pointer 
is returned.\\
\\ 
There are several other methods available in order to operate with 
objects through the index access:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{const pxl::Index}\& \emph{pxl::ObjectOwner::getIndex() const}\\
\emph{void pxl::ObjectOwner::removeIndex(const std::string} \& \emph{idx )}\\
\emph{void pxl::ObjectOwner::clearIndex ()}.
\vspace{0.2cm} 
\end{minipage}}\\
\\
The \emph{getIndex()} method, as usually, provides direct read access to the index. 
Using \emph{removeIndex()} one can remove the index entry with index-id (\emph{idx}).
The \emph{clearIndex()} method clears all index values of the object owner. 
Note that the previous two methods do not remove the objects themselves from the object owner.\\
\\
There are several options to access only objects of a certain type. The suggested way is to use the method
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{int pxl::ObjectOwner::getObjectsOfType$\langle$objecttype$\rangle$(std::vector$\langle$objecttype*$\rangle$} \&\emph{vec) const}
\vspace{0.2cm} 
\end{minipage}}\\
\\
which adds pointers at all objects which can be interpreted as type objecttype (tested by dynamic casts) to the passed \emph{std::vector$\langle$objecttype*$\rangle$}.
In addition, PXL also offers a selective iterator, the so-called \emph{TypeIterator}.
%-


\subsubsection*{EventView, Event}
%-
As already mentioned, event containers such as Event or EventView  
deploy most of the methods of the ObjectOwner for an easier user syntax (the methods are passed to the contained ObjectOwner).
Below you can find a simple example which shows how to create an event
container with several physics objects, and relations, and how to delete it,
using the ObjectOwner-like methods:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// create an event container, give it a name and set its run number to 2008:}\\
\texttt{pxl::EventView* ev = new pxl::EventView();}\\
\texttt{ev->setName("reconstructed")};\\
\texttt{ev->setUserRecord<int>("run nr.", 2008)};\\
\\
\texttt{// create Relative derivatives: particles and vertices:}\\
\texttt{pxl::Vertex* vtx = ev->create<pxl::Vertex>()}\\
\texttt{pxl::Particle* W = ev->create<pxl::Particle>();}\\
\\
\texttt{W->linkMother(vtx);}\\
\\
\texttt{// check if W belong to the event view \emph{ev}}\\
\texttt{std::cout<< ev->getObjectOwner().has(W) <<std::endl;}\\
\texttt{ev->print();}\\
\\
\texttt{// here event container is deleted:}\\
\texttt{delete ev;}
\vspace{0.2cm}
\end{minipage}}\\
\\
%-
Here is an example how one can iterate over vertices of the event container:\\
\\  
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// Get particles from the ObjectOwner and iterate:}\\
\texttt{pxl::EventView* ev = new pxl::EventView();}\\
\\
\texttt{std::vector<pxl::Particle*> particles;}\\
\texttt{ev->getObjectsOfType<pxl::Particle>(particles);}\\
\texttt{for (std::vector<pxl::Particle*>::const\_iterator pIt} = \texttt{particles.begin();}\\
\texttt{pIt != particles.end(); ++pIt)}\\
\texttt{\{}\\
	\texttt{pxl::Particle* containedPart = *pIt;}\\
	\texttt{containedPart->print();}\\
\texttt{\}}
\vspace{0.2cm}
\end{minipage}}

Another coding example of how to create an event container with physics 
objects and relations using the object index is shown below. \\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// here we create an event container and set its run number to 2009:}\\
\texttt{pxl::Event* event = new pxl::Event();}\\
\texttt{ev->setUserRecord<int>("run nr.", 2009)};\\
\\
\texttt{// create two event views, directly make an index entry:}\\
\texttt{pxl::EventView* ev1 = event->createIndexed<pxl::EventView>("generated");}
\texttt{pxl::EventView* ev2 = event->createIndexed<pxl::EventView>("reconstructed");}
\\
\texttt{ev1->linkFlat(ev2); // create flat relation between event views}\\
\\
\texttt{// create physics objects within the EventViews:}\\
\texttt{pxl::Particle* t1 = ev1->create<pxl::Particle>("t");}\\
\texttt{pxl::Particle* W1 = ev1->create<pxl::Particle>("W");}\\
\texttt{W->linkMother(t);}\\
\\
\texttt{// here we print our decay tree:}\\
\texttt{ev1->printDecayTree();}\\
\\
\texttt{// here event containers are deleted:}\\
\texttt{delete event;}
\vspace{0.2cm}
\end{minipage}}
%-


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% first_part %%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Pointer and Weak Pointer}
\label{subsec_wkptr}
%
Weak pointers can be used in order to set a "safe" pointer to
any PXL object.
Weak pointers to \emph{pxl::Relative} derivatives can be created via the \emph{pxl::weak\_ptr} 
template class. This weak pointer can be checked and provides safe 
access to the referenced objects by the methods \emph{valid()} or by implicit conversion to \emph{bool}
which return true if the referenced object still exists: \\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\emph{bool pxl::WkPtrBase::valid() const}\\
\emph{operator bool()}\\
\vspace{0.2cm} 
\end{minipage}}\\
\\ 
This concept helps, for instance, to avoid a problem of broken pointers in case of object deletion. 
Users can create and use a weak pointer to any PXL object in 
the same way as a normal pointer.\\
\\
An example how weak pointers can be used in the analysis code is shown below:\\
\\  
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// create an EventView:}\\
\texttt{pxl::EventView* ev = new pxl::EventView();}\\
\\
\texttt{// We can implicitly convert a returned pointer to a pxl::weak\_ptr}\\
\texttt{pxl::weak\_ptr<pxl::Particle> partWkPtr = ev->create<pxl::Particle>();}\\
\\
\texttt{// Access with the -> operator:}\\
\texttt{partWkPtr->setName("jet");}\\
\texttt{// ... or with the ptr() method:}\\
\texttt{partWkPtr.ptr()->setP4(10., 10., 10., 30.);}\\
\texttt{// ... or with the object() method}\\
\texttt{partWkPtr.object().print();}\\
\\
\texttt{// Check if the weak pointer is still valid:}\\
\texttt{if (partWkPtr)}\\
\texttt{std::cout<< "wk\_ptr still valid." <<std::endl;}\\
\texttt{else}\\
\texttt{std::cout<< "wk\_ptr not valid!" << std::endl;}\\
\texttt{std::cout<< "Alternative syntax. Valid? " << partWkPtr.valid() <<std::endl;}\\
\texttt{std::cout<< "This is not possible for a normal pointer -" <<std::endl;}\\
\texttt{std::cout<< "this would be a hard-to-trace bug." <<std::endl;}\\
\texttt{\}}
\vspace{0.2cm}
\end{minipage}}


\section{PXL I/O}
\label{sec_io}

PXL offers its own I/O file format with the default filename extension 
\emph{pxlio}. The I/O scheme 
performs the storage of the physics objects including relations, user 
records, etc. The implementation uses the ZLIB library for
data compression. \\
\\
The file compression is organized in binary data chunks where the
main unit is a physics event (please note that this does not mean the PXL event class). Since all files are zipped on the event base, 
the user has access to each event separately.
This structure has been developed in order to keep information about the whole event in one unit, starting from all possible reconstructed 
and/or generated \emph{pxl::EventView}s, the contained 
relations, user records and \emph{pxl::Serializable}s (basic class in PXL 
for input/output). Figure \ref{fig_event}
shows several possibilities for a physics event structure of a PXL I/O file.
Every event chunk carrys a header and the compressed binary data. It can also 
contain an information chunk. The event header contains the general 
information about the zipped event: event marker, compression mode,
and data amount information. The PXL objects are stored in the event 
data block(s). The last example in Figure \ref{fig_event} shows the case
where an information chunk, with the according PXL class \emph{pxl::InformationChunk} which mainly carries user information, is 
used. The information chunk allows to structure I/O files by providing information about whole files, or parts of the file. It can be inserted at any place of the file instead of an event chunk.
%
\begin{figure}[t]
\begin{center}
\setlength{\unitlength}{1cm}
\begin{picture}(13.0,7.5)
{\includegraphics[width=13cm]{plots/event_structure}}
\end{picture}
\caption{Several possible structures of the physics event or an information chunk within a PXL I/O file.}
\label{fig_event}
\end{center}
\end{figure}
%
The important point of the event-based data compression strategy is that
a file is still usable after a potential program crash.
Note, however, that immediate information about the total event number in a file is not available.\\
\\
Below you can find two examples: a first one is how a PXL I/O file can be 
created and filled; the second shows how to read a PXL I/O file containing
\emph{pxl::Event}s.\\
\\  
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{// create a new pxl::OutputFile object}\\
\texttt{// with the filename as constructor argument:}\\
\texttt{pxl::OutputFile outFile("pxlexample\_1.pxlio");}\\
\\
\texttt{// fill the output file}\\
\texttt{for (int i=0; i<100; ++i) \{ }\\
\\
\texttt{std::auto\_ptr<pxl::Event> newEvent(new pxl::Event());}\\
\texttt{pxl::EventViewWkPtr evtView = newEvent->create<pxl::EventView>();}\\
\\
\texttt{// create electron:}\\
\texttt{pxl::ParticleWkPtr electron1 = evtView->create<pxl::Particle>();}\\
\texttt{electron1->setP4(40., -20., 31., 80.);}\\
\texttt{electron1->setName("electron");}\\
\texttt{if (i==0) electron1->print();}\\
\\
\texttt{// create Z-boson (mother particle):}\\
\texttt{pxl::ParticleWkPtr zboson = evtView->create<pxl::Particle>();}\\
\texttt{zboson->setName("Z");}\\
\texttt{zboson->linkDaughter(electron1);}\\
\texttt{if (i==0) zboson->print();}\\
\\
\texttt{if (i==0)}\\
\texttt{std::cout << "For each event, use the writeEvent method to write the complete physics event to disk."}\\
\texttt{<< std::endl;}\\
\texttt{outFile.writeEvent(newEvent.get());}\\
\texttt{\}}
\vspace{0.2cm}
\end{minipage}}\\
\\  
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{int nEvents = 0;}\\
\texttt{// Book an input file, and advance events with the next() method}\\
\texttt{pxl::InputFile inputFile("pxlexample\_1.pxlio");}\\
\\
\texttt{while (inputFile.next()) \{}\\
\texttt{nEvents++;}\\
\\
\texttt{// book a pxl::Event, and use the readEvent method}\\
\texttt{// to fill it with contents:}\\
\texttt{if (nEvents==1)}\\
\texttt{pxl::Event* event(new pxl::Event);}\\
\\
\texttt{//Get the contained EventViews, and then the Particles contained therein:}\\
\texttt{while (inputFile.readEvent(event)) \{}\\
\\
\texttt{if (nEvents==1) \{}\\
\texttt{event->print();}\\
\texttt{\}}\\
\texttt{std::vector<pxl::EventView*> eventViews;}\\
\texttt{event->getObjectsOfType<pxl::EventView>(eventViews);}\\
\\
\texttt{for (std::vector<pxl::EventView*>::const\_iterator it =}\\
\texttt{eventViews.begin(); it != eventViews.end(); ++it)}\\
\texttt{\{}\\
\texttt{std::vector<pxl::Particle*> particles;}\\
\texttt{pxl::EventView* evView = *it;}\\
\texttt{evView->getObjectsOfType<pxl::Particle>(particles);}\\
\\
\texttt{for (std::vector<pxl::Particle*>::const\_iterator pIt =}\\
\texttt{particles.begin(); pIt != particles.end(); ++pIt) \{} \\
\\
\texttt{pxl::Particle* zboson = *pIt;}\\
\texttt{if (zboson->getMotherRelations().size()==0 \&\& nEvents==1)}\\
\texttt{zboson->print();}\\
\texttt{\}}\\
\\
\texttt{\}}\\
\texttt{\}}\\
\texttt{delete event;}\\
\\
\texttt{std::cout << "Processed " << nEvents << " events. " << std::endl;}\\
\texttt{\}}
\vspace{0.2cm}
\end{minipage}}

\newpage

%-
\section{Additional Options}
\label{sec_extra}
%
\begin{figure}[t]
\begin{center}
\setlength{\unitlength}{1cm}
\begin{picture}(10.0,4.0)
{\includegraphics[width=10cm]{plots/extra_class}}
\end{picture}
\caption{ User-defined \emph{myParticle} class, inherited from
\emph{pxl::Particle}.}
\label{fig_myclass}
\end{center}
\end{figure}
%
PXL allows an analyser to include her self-defined C++ classes.
The condition for usage of such a class is that it has to inherit from a corresponding 
PXL object. To be included in the PXL I/O scheme, the class needs to inherit from \emph{pxl::Serializable} and implement the corresponding serialization methods. To make use of the relation management, the corresponding class to inherit from is \emph{pxl::Relative}, et cetera.

Consider the case where the user has defined her own \emph{myParticle} 
class (see Figure \ref{fig_myclass}). In this case \emph{myParticle}
can be treated further whithin PXL as a regular PXL object. 
Moreover, \emph{myParticle} need not be just a general particle, but can
also be a specific one, like muon, electron etc. Here PXL gives
the analyser a high degree of freedom. \\
\\
Another example where PXL offers generic utitilies are filter classes. By defining a filter criterion and a comparator class for object ordering, any filter can be created. E.g., to provide a pT-sorted filter for PXL physics objects, one
can use the ore-implemented class \emph{pxl::ParticlePtComparator}:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\begin{tabular}{l l }
\emph{virtual bool pxl::ParticlePtComparator::operator()} &  \emph{( pxl::Particle p1,}\\
                                                  &   \emph{pxl::Particle p2 )}\\
\end{tabular}
\vspace{0.2cm}
\end{minipage}}\\
\\ 
where \emph{p1} and \emph{p2} are names of the particles and compared values
could be $p_T$ or $\eta$ of these particles. Below we show a scripting example 
how similar classes can be used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{\{}\\
\texttt{// Create EventView with two particles}\\
\texttt{pxl::EventView* ev = new pxl::EventView();}\\
\\
\texttt{pxl::Particle* gluon = ev->createIndexed<pxl::Particle>("gluon");}\\
\texttt{gluon->setName("gluon");}\\
\texttt{pxl::Particle* b = ev->createIndexed<pxl::Particle>("b");}\\
\texttt{b->setName("b");}\\
\texttt{b->setP4(20., 25., 0., 35.);}\\
\texttt{pxl::Particle* bbar = ev->createIndexed<pxl::Particle>("bbar");}\\
\texttt{bbar->setName("bbar");}\\
\texttt{bbar->setP4(100., 100., 0., 142.);}\\
\\
\texttt{// Filter and pt-sort particles}\\
\texttt{pxl::ParticleFilter filter;}\\
\texttt{std::vector<pxl::Particle*> particles;}\\
\\
\texttt{// Choose a pt, eta, name filter criterion}\\
\texttt{pxl::ParticlePtEtaNameCriterion crit("", 0., 0.);}\\
\texttt{filter.apply(\&ev->getObjectOwner(), particles, crit);}\\
\\
\texttt{// print, sorted by pT:}\\
\texttt{for (std::vector<pxl::Particle*>::const\_iterator iter =}\\
\texttt{particles.begin(); iter!=particles.end(); ++iter) \{}\\
\texttt{pxl::ParticleWkPtr pa = *iter;}\\
\texttt{std::cout << " " << pa->getName();}\\
\texttt{std::cout << ", pT = " << pa->getPt();}\\
\texttt{std::cout << std::endl;}\\
\texttt{\}}\\
\texttt{delete ev;}\\
\texttt{\}}
\vspace{0.2cm}
\end{minipage}}


%-
\section{Technical details}

\subsection{PXL Classes}
\label{sec_pxl_classes}

The PXL C++ toolkit is an open source software and avaliable online 
\cite{pxl-web}. The project is a successor project of the Physics Analysis 
eXpert (PAX) package 
\cite{Erdmann:2002wn,Erdmann:2003ke,chep04,Kappler:2005tf,Kappler:2006uq}.
With its user-friendly interface and high performance,
PXL is based on the ANSI C++ language standard together with the Standard 
Template Library (STL) and uses ZLIB data compression library. \\
\\
The PXL uses an own single C++ namespace, \emph{pxl}, and is organized 
in the following subpackages:
   
\begin{itemize}
\item {physics (Physics Library)}
\item {base (Base Library) }
\item {I/O (I/O Library)}
\end{itemize}
%-
The \emph{physics} library contains generalized physics objects and event 
containers such as particles or reconstructed objects,
%and other tools required for the abstract fourvector analysis,  
\emph{pxl::Particle}, spatial points of particle decay 
\emph{pxl::Vertex}, individual interactions supported in 
\emph{pxl::Collision} in events with multiple collisions. 
Generalized event containers for 
particles, vertices and collisions or user-defined objects are
\emph{pxl::EventView} and \emph{pxl::Event}. In addition, the \emph{physics} 
library contains base classes for manageing multiple event 
views or objects, \emph{pxl::AnalysisProcess}, and the base class 
for managing a hierarchy of analysis forks, processes and event views,
\emph{pxl::AnalysisFork}, and a class for adding general information 
in files, \emph{pxl::InformationChunk}.\\
\\
The \emph{base} library holds other objects and tools required for the 
abstract fourvector analysis in PXL. These classes are objects with 
mother/daughter/flat relations and data, \emph{pxl::Relative},
and the container for PXL objects, \emph{pxl::ObjectOwner}. It also
contains classes for management of relations between objects, 
\emph{pxl::Relations}, management of soft relations, \emph{pxl::SoftRelations},
weak pointers to \emph{pxl::Relative} derivatives, \emph{pxl::weak\_ptr},
and the \emph{pxl::UserRecord} container for user data handling. \\
\\
The last library, I/O, includes the classes for reading and
writing files from disk, e.g. \emph{pxl::InputFile} and \emph{pxl::outputFile}.

\subsection{Copy-On-Write Concept}
\label{subsec_cow}
The evolution of different hypotheses for the same event, a task arising 
during the reconstruction of processes with multiple reconstructed objects
of the same type, can be done by making copies of the event data with 
subsequent hypothesis-specific modifications. This procedure is convenient
and easy to program - however, most of the hypotheses require only a part 
of the event data, so it leads to unnecessary use of CPU and memory
resources. In order to avoid this problem, PXL provides a Copy-On-Write 
(COW) class template. The copy constructor of these class templates copies 
established relations while leaving the actual data untouched. The 
reference counting mechanism ensures, that only upon write access the data
is copied. A typical example of a class
template managed by the COW mechanism is the \emph{pxl::UserRecord} of 
the physics objects, described in a previous section. Below one can find 
an example how the COW concept can be used:\\
\\
\shadowbox{%
\begin{minipage}{6.6in}
\vspace{0.2cm}
\texttt{\{}\\
\texttt{// create an EventView:}\\
\texttt{pxl::EventView* ev = new pxl::EventView();}\\
\texttt{ev->setUserRecord<int>("run nr.", 192168);}\\
\\
\texttt{// display UserRecord entry:}\\
\texttt{std::cout << ev->findUserRecord<int>("run nr.") << std::endl;}\\
\texttt{// Map of original UserRecord resides at:}\\
\texttt{std::cout << ev->getUserRecord().getContainer() << std::endl;}\\
\\
\texttt{// create a copy of existing EventView (ev):}\\
\texttt{pxl::EventView* ev\_copy = new pxl::EventView(ev);}\\
\texttt{// map of copied event's UserRecord resides at:}\\
\texttt{std::cout << ev->getUserRecord().getContainer() << std::endl;}\\
\\
\texttt{ev\_copy->setUserRecord<int>("run nr.", 1921124);}\\
\texttt{// display modified UserRecord entry:}\\
\texttt{std::cout << ev\_copy->findUserRecord<int>("run nr.") << std::endl;}\\
\texttt{// map of copied event's modified UserRecord resides at:}\\
\texttt{std::cout << ev\_copy->getUserRecord().getContainer() << std::endl;}\\
\\
\texttt{// display original UserRecord entry:}\\
\texttt{std::cout << ev->findUserRecord<int>("run nr.") << std::endl;}\\
\\
\texttt{delete ev;}\\
\texttt{delete ev\_copy;}\\
\texttt{\}}
\vspace{0.2cm}
\end{minipage}}


%-
\subsection{UUID}
%-
PXL uses a standard Universally Unique IDentifier (UUID)
to assign a unique ID for each object, \emph{pxl::Serializable}, and also for
each object type as \emph{pxl::Particle}, \emph{pxl::Vertex} etc. The main 
reason of UUID implementation is the unique identification of each object
in a complex code without significant central coordination.


\section{ PXL download and installation}
The PXL kernel is kept in the $\text{http://pxl.sourceforge.net/}$ subversion 
repository 
and can be checked out through SVN with the following instruction set:\\
$$\text{svn co https://pxl.svn.sourceforge.net/svnroot/pxl pxl}$$\\
Using this checkout command one will pull all modules, tags and/or branches 
of the project. In most cases, the user will want to add '/trunk' 
to the HTTPS URL above to check out only trunk (main development line).
The last version of the PXL (v2.0.0) also can be directly downloaded from:\\
$$\text{http://pxl.sourceforge.net/downloads.html}$$\\
Clicking on $\text{pxl-2.0.0.tar.bz2}$ you can dowload a compressed tar-file
and install PXL as following:\\
\\
$>$ \text{tar~ -xvjf~ pxl-2.0.0.tar.bz2~ -C~ pxl-2.0.0}\\
\\
to extract the tarball contents into the pxl-2.0.0 directory. Then change 
the directory:\\
\\
$>$ \text{cd~ pxl-2.0.0}\\
\\
In this directory you will find an INSTALL file where the main steps 
of the pretty standard PXL installation are described. 
First, in the current directory one should type:\\
\\ 
$>$ ./configure\\ 
\\ 
to configure the package for your system. Then, to compile the package and 
to install the programs type\\
\\
$>$ make \\
$>$ make install \\
\\
PXL can be installed at any platform. The recommended operating 
systems are: 64-bit MS Windows, all 32-bit MS Windows (95/98/NT/2000/XP), 
all POSIX (Linux/BSD/UNIX-like OSes) and MacOS. \\
 


\renewcommand{\baselinestretch}{1.0}
{\Large\normalsize}
\begin{thebibliography}{8}
\pdfbookmark[0]{References}{ref}

\bibitem{pxl-web}
O.~Actis, M.~Erdmann, A.~Hinzmann, T.~Klimkovich, G.~M\"uller, J.~Steggemann 
https://pxl.svn.sourceforge.net/svnroot/pxl

\bibitem{auto}
O.~Actis, M.~Erdmann, A.~Hinzmann, M.~Kirsch, G.~M\"uller, J.~Steggemann,    
``An Algorithm for Automated Reconstruction of Particle Cascades in High 
Energy Physics Experiments'', (2008), [arXiv:0801.1302].

\bibitem{Erdmann:2002wn}
  M.~Erdmann, D.~Hirschb\"{u}hl, Y.~Kemp, P.~Schemitz, T.~Walter,
  ``Physics analysis expert'',
  Proc. of the 14th Topical Conference on Hadron Collider Physics (HCP 2002), 
  Karlsruhe, Germany, (2002), publ. by Springer Verlag, Berlin, Germany, (2003).

%\cite{Erdmann:2003ke}
\bibitem{Erdmann:2003ke}
  M.~Erdmann, D.~Hirschb\"{u}hl, C.~Jung, S.~Kappler, Y.~Kemp, M.~Kirsch,
  ``Physics analysis expert PAX: First applications'',
  Proc. of 2003 Conference for Computing in High-Energy and Nuclear Physics 
  (CHEP 03), La Jolla, California, (2003), [arXiv:physics/0306085].

\bibitem{chep04}
  M.~Erdmann, U.~Felzmann, D.~Hirschb\"uhl, C.~Jung, S.~Kappler, M.~Kirsch, 
  G.~Quast, K.~Rabbertz, J.~Rehn, S.~Schalla, P.~Schemitz, A.~Schmidt, T.~Walter,
  C.~Weiser,
  ``New Applications of PAX in Physics Analyses at Hadron Colliders'',
  Proc. of the Conference on Computing in High Energy and Nuclear Physics 
  (CHEP04), Interlaken, Switzerland, (2004).

%\cite{Kappler:2005tf}
\bibitem{Kappler:2005tf}
  S.~Kappler, M.~Erdmann, U.~Felzmann, D.~Hirschb\"uhl, M.~Kirsch, 
  G.~Quast, A.~Schmidt, J.~Weng,
  ``The PAX toolkit and its applications at Tevatron and LHC'',
  IEEE Trans.\ Nucl.\ Sci.\  {\bf 53}, 506 (2006),
  [arXiv:physics/0512232].
  %%CITATION = IETNA,53,506;%%

%\cite{Kappler:2006uq}
\bibitem{Kappler:2006uq}
  S.~Kappler, M.~Erdmann, M.~Kirsch, G.~M\"uller, J.~Weng, A.~Flossdorf, 
  U.~Felzmann, G.~Quast, C.~Saout, A.~Schmidt,
  ``Concepts, developments and advanced applications of the PAX toolkit'',
 Proc. of the Conference on Computing in High Energy and Nuclear Physics 
 (CHEP06), Mumbai, India, (2006),
  [arXiv:physics/0605063].
  %%CITATION = PHYSICS/0605063;%%

\end{thebibliography}


\end{document}
